diff --git a/libavfilter/Makefile b/libavfilter/Makefile
index d69bd59bb6..bdfdfdc04a 100644
--- a/libavfilter/Makefile
+++ b/libavfilter/Makefile
@@ -279,6 +279,7 @@ OBJS-$(CONFIG_ESTDIF_FILTER)                 += vf_estdif.o
 OBJS-$(CONFIG_EXPOSURE_FILTER)               += vf_exposure.o
 OBJS-$(CONFIG_EXTRACTPLANES_FILTER)          += vf_extractplanes.o
 OBJS-$(CONFIG_FADE_FILTER)                   += vf_fade.o
+OBJS-$(CONFIG_FEEDBACK_FILTER)               += vf_feedback.o
 OBJS-$(CONFIG_FFTDNOIZ_FILTER)               += vf_fftdnoiz.o
 OBJS-$(CONFIG_FFTFILT_FILTER)                += vf_fftfilt.o
 OBJS-$(CONFIG_FIELD_FILTER)                  += vf_field.o
diff --git a/libavfilter/allfilters.c b/libavfilter/allfilters.c
index abd1fe2367..44fac46521 100644
--- a/libavfilter/allfilters.c
+++ b/libavfilter/allfilters.c
@@ -261,6 +261,7 @@ extern const AVFilter ff_vf_estdif;
 extern const AVFilter ff_vf_exposure;
 extern const AVFilter ff_vf_extractplanes;
 extern const AVFilter ff_vf_fade;
+extern const AVFilter ff_vf_feedback;
 extern const AVFilter ff_vf_fftdnoiz;
 extern const AVFilter ff_vf_fftfilt;
 extern const AVFilter ff_vf_field;
diff --git a/libavfilter/vf_feedback.c b/libavfilter/vf_feedback.c
new file mode 100644
index 0000000000..eb3ac4539d
--- /dev/null
+++ b/libavfilter/vf_feedback.c
@@ -0,0 +1,249 @@
+/*
+ * This file is part of FFmpeg.
+ *
+ * FFmpeg is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU Lesser General Public
+ * License as published by the Free Software Foundation; either
+ * version 2.1 of the License, or (at your option) any later version.
+ *
+ * FFmpeg is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * Lesser General Public License for more details.
+ *
+ * You should have received a copy of the GNU Lesser General Public
+ * License along with FFmpeg; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+/**
+ * @file
+ * feedback video filter
+ */
+
+#include "libavutil/avstring.h"
+#include "libavutil/imgutils.h"
+#include "libavutil/opt.h"
+#include "libavutil/internal.h"
+#include "avfilter.h"
+#include "filters.h"
+#include "internal.h"
+#include "video.h"
+
+typedef struct FeedbackContext {
+    const AVClass *class;
+
+    int x[2];
+    int y[2];
+
+    int max_step[4];
+    int hsub, vsub;
+
+    AVFrame *in[2];
+} FeedbackContext;
+
+static int config_input(AVFilterLink *inlink)
+{
+    AVFilterContext *ctx = inlink->dst;
+    const AVPixFmtDescriptor *pix_desc = av_pix_fmt_desc_get(inlink->format);
+    FeedbackContext *s = ctx->priv;
+
+    if (s->x[0] >= ctx->inputs[0]->w)
+        s->x[0] = 0;
+
+    if (s->x[1] >= ctx->inputs[0]->w)
+        s->x[1] = ctx->inputs[0]->w;
+
+    if (s->y[0] >= ctx->inputs[0]->h)
+        s->y[0] = 0;
+
+    if (s->y[1] >= ctx->inputs[0]->h)
+        s->y[1] = ctx->inputs[0]->h;
+
+    s->hsub = pix_desc->log2_chroma_w;
+    s->vsub = pix_desc->log2_chroma_h;
+
+    av_image_fill_max_pixsteps(s->max_step, NULL, pix_desc);
+
+    ctx->inputs[1]->w = s->x[1] <= s->x[0] ? ctx->inputs[0]->w - s->x[0] : s->x[1] - s->x[0];
+    ctx->inputs[1]->h = s->y[1] <= s->y[0] ? ctx->inputs[0]->h - s->y[0] : s->y[1] - s->y[0];
+
+    return 0;
+}
+
+static int config_output(AVFilterLink *outlink)
+{
+    AVFilterContext *ctx = outlink->src;
+    FeedbackContext *s = ctx->priv;
+
+    ctx->outputs[0]->w = ctx->inputs[0]->w;
+    ctx->outputs[0]->h = ctx->inputs[0]->h;
+    ctx->outputs[1]->w = s->x[1] <= s->x[0] ? ctx->inputs[0]->w - s->x[0] : s->x[1] - s->x[0];
+    ctx->outputs[1]->h = s->y[1] <= s->y[0] ? ctx->inputs[0]->h - s->y[0] : s->y[1] - s->y[0];
+
+    return 0;
+}
+
+static int query_formats(AVFilterContext *ctx)
+{
+    return ff_set_common_formats(ctx, ff_formats_pixdesc_filter(0, AV_PIX_FMT_FLAG_HWACCEL |
+                                                                   AV_PIX_FMT_FLAG_PAL));
+}
+
+static int activate(AVFilterContext *ctx)
+{
+    FeedbackContext *s = ctx->priv;
+    int status, ret;
+    int64_t pts;
+
+    for (int i = 0; i < ctx->nb_outputs; i++)
+        FF_FILTER_FORWARD_STATUS_BACK_ALL(ctx->outputs[i], ctx);
+
+    if (!s->in[0]) {
+        ret = ff_inlink_consume_frame(ctx->inputs[0], &s->in[0]);
+        if (ret < 0)
+            return ret;
+
+        if (ret > 0) {
+            AVFrame *frame = av_frame_clone(s->in[0]);
+            if (!frame) {
+                av_frame_free(&s->in[0]);
+                return AVERROR(ENOMEM);
+            }
+
+            frame->width  = s->x[1] <= s->x[0] ? frame->width  - s->x[0] : s->x[1] - s->x[0];
+            frame->height = s->y[1] <= s->y[0] ? frame->height - s->y[0] : s->y[1] - s->y[0];
+
+            frame->data[0] += s->y[0] * frame->linesize[0];
+            frame->data[0] += s->x[0] * s->max_step[0];
+
+            for (int i = 1; i < 3; i ++) {
+                if (frame->data[i]) {
+                    frame->data[i] += (s->y[0] >> s->vsub) * frame->linesize[i];
+                    frame->data[i] += (s->x[0] * s->max_step[i]) >> s->hsub;
+                }
+            }
+
+            if (frame->data[3]) {
+                frame->data[3] += s->y[0] * frame->linesize[3];
+                frame->data[3] += s->x[0] * s->max_step[3];
+            }
+
+            return ff_filter_frame(ctx->outputs[1], frame);
+        }
+    } else {
+        ret = ff_inlink_consume_frame(ctx->inputs[1], &s->in[1]);
+        if (ret < 0)
+            return ret;
+
+        if (ret > 0) {
+            AVFrame *dst = s->in[0];
+            AVFrame *src = s->in[1];
+
+            for (int y = 0; y < src->height; y++) {
+                memmove(dst->data[0] + (s->y[0] + y) * dst->linesize[0] + s->x[0] * s->max_step[0],
+                        src->data[0] + y * src->linesize[0], src->width * s->max_step[0]);
+            }
+
+            for (int i = 1; i < 3; i ++) {
+                if (dst->data[i]) {
+                    for (int y = 0; y < src->height; y++) {
+                        memmove(dst->data[i] + ((s->y[0] + y) >> s->vsub) * dst->linesize[i] + ((s->x[0] * s->max_step[i]) >> s->hsub),
+                                src->data[i] + (y >> s->vsub) * src->linesize[i], (src->width * s->max_step[i]) >> s->hsub);
+                    }
+                }
+            }
+
+            if (dst->data[3]) {
+                for (int y = 0; y < src->height; y++) {
+                    memmove(dst->data[3] + (s->y[0] + y) * dst->linesize[3] + s->x[0] * s->max_step[3],
+                            src->data[3] + y * src->linesize[3], src->width * s->max_step[3]);
+                }
+            }
+
+            ret = ff_filter_frame(ctx->outputs[0], s->in[0]);
+            av_frame_free(&s->in[1]);
+            s->in[0] = NULL;
+            return ret;
+        }
+    }
+
+    if (ff_inlink_acknowledge_status(ctx->inputs[0], &status, &pts)) {
+        ff_outlink_set_status(ctx->outputs[0], status, pts);
+        ff_outlink_set_status(ctx->outputs[1], status, pts);
+        return 0;
+    }
+
+    if (ff_inlink_acknowledge_status(ctx->inputs[1], &status, &pts)) {
+        ff_outlink_set_status(ctx->outputs[0], status, pts);
+        ff_outlink_set_status(ctx->outputs[1], status, pts);
+        return 0;
+    }
+
+    if (!s->in[0])
+        FF_FILTER_FORWARD_WANTED(ctx->outputs[0], ctx->inputs[0]);
+    if (!s->in[1])
+        FF_FILTER_FORWARD_WANTED(ctx->outputs[0], ctx->inputs[1]);
+
+    return FFERROR_NOT_READY;
+}
+
+static av_cold void uninit(AVFilterContext *ctx)
+{
+    FeedbackContext *s = ctx->priv;
+
+    av_frame_free(&s->in[0]);
+    av_frame_free(&s->in[1]);
+}
+
+static const AVFilterPad inputs[] = {
+    {
+        .name         = "default",
+        .type         = AVMEDIA_TYPE_VIDEO,
+        .config_props = config_input,
+    },
+    {
+        .name         = "feedinput",
+        .type         = AVMEDIA_TYPE_VIDEO,
+        .config_props = config_input,
+    },
+};
+
+static const AVFilterPad outputs[] = {
+    {
+        .name         = "default",
+        .type         = AVMEDIA_TYPE_VIDEO,
+        .config_props = config_output,
+    },
+    {
+        .name         = "feedoutput",
+        .type         = AVMEDIA_TYPE_VIDEO,
+        .config_props = config_output,
+    },
+};
+
+#define OFFSET(x) offsetof(FeedbackContext, x)
+#define FLAGS (AV_OPT_FLAG_VIDEO_PARAM | AV_OPT_FLAG_FILTERING_PARAM)
+
+static const AVOption feedback_options[] = {
+    { "x0", "set x0 crop position", OFFSET(x[0]), AV_OPT_TYPE_INT, { .i64 = 0 }, 0, INT_MAX, FLAGS },
+    { "y0", "set y0 crop position", OFFSET(y[0]), AV_OPT_TYPE_INT, { .i64 = 0 }, 0, INT_MAX, FLAGS },
+    { "x1", "set x1 crop position", OFFSET(x[1]), AV_OPT_TYPE_INT, { .i64 = 0 }, 0, INT_MAX, FLAGS },
+    { "y1", "set y1 crop position", OFFSET(y[1]), AV_OPT_TYPE_INT, { .i64 = 0 }, 0, INT_MAX, FLAGS },
+    { NULL }
+};
+
+AVFILTER_DEFINE_CLASS(feedback);
+
+const AVFilter ff_vf_feedback = {
+    .name        = "feedback",
+    .description = NULL_IF_CONFIG_SMALL("Apply feedback video filter."),
+    .priv_class  = &feedback_class,
+    .priv_size   = sizeof(FeedbackContext),
+    .activate    = activate,
+    .uninit      = uninit,
+    FILTER_INPUTS(inputs),
+    FILTER_OUTPUTS(outputs),
+    FILTER_QUERY_FUNC(query_formats),
+    .flags       = AVFILTER_FLAG_METADATA_ONLY,
+};